Manipulate listview as grid layout in Vue Listview component

8 Aug 202317 minutes to read

In Listview, list items can be rendered in grid layout with following data manipulations.

  • Add Item

  • Remove Item

  • Sort Items

  • Filter Items

Grid Layout

In this section, we will discuss about rendering of list items in grid layout.

  • Initialize and render ListView with dataSource which will render list items in list layout.

  • Now, add the below CSS to list item. This will make list items to render in grid layout

     #element .e-list-item {
          height: 100px;
          width: 100px;
          float: left; 
       }  
    

In the below sample, we have rendered List items in grid layout.

<template>
  <div id="sample">
    <ejs-listview id='element' :dataSource='data' :template='listTemplate'>
    </ejs-listview>
  </div>
</template>
<style>
#element {
    display: block;
    max-width: 303px;
    margin: auto;
    border: 1px solid #dddddd;
    border-radius: 3px;
}

#element .e-list-item {
    height: 100px;
    width: 100px;
    float: left;
    padding: 0;
}

#listImage {
    width: 55px;
    height: 55px;
    margin-left: 20px;
    margin-top: 20px;

}
</style>
<script>
import Vue from "vue";
import { ListViewPlugin } from "@syncfusion/ej2-vue-lists";

Vue.use(ListViewPlugin);

var listVue = Vue.component("demo", {
  template: `<img id="listImage" src="https://ej2.syncfusion.com/documentation/code-snippet/listview/grid-layout-cs1/apple.png" alt="apple" />`,
  data() {
    return {
      data: {}
    };
  }
});

export default {
  data: function() {
         return {
    data: [1, 2, 3, 4, 5, 6, 7, 8, 9],
    listTemplate: function () {
      return { template : listVue}
    },
  };
}
}
</script>

Data manipulation

In this section, we will discuss about ListView data manipulations.

Add Item

We can add list item using addItem API. This will accept array of data as argument.

    this.$refs.listViewInstance.addItem([{text: 'Apricot', id: '32'}]);

In the below sample, you can add new fruit item by clicking add button which will open dialog box with fruit name and image URL text box. After entering the item details, click the add button. This will add your new fruit item.

Remove item

We can remove list item using removeItem API. This will accept fields with id or list item element as argument.

    this.$refs.listViewInstance.removeItem({id: '32'});

In the below sample, you can remove fruit by hovering the fruit item which will show delete button and click that delete button to delete that fruit from your list.

Sort Items

Listview can be sorted either in Ascending or Descending order. To enable sorting in your ListView, set sortOrder as Ascending or Descending.

    <ejs-listview sortOrder='Ascending'></ejs-listview>

We can also set sorting after component initialization.

    this.$refs.listViewInstance.sortOrder = 'Ascending'

In the below sample, we have sorted fruits in Ascending order. To sort it in descending, click on sort order icon and vice versa.

Filter Items

Listview data can be filtered with the help of dataManager. After filtering the data, update ListView dataSource with filtered data.

   let value = this.$refs.textboxEle.value;  //input text box value
   let filteredData = new DataManager(this.listdata).executeLocal(
        new Query().where("text", "startswith", value, true)
   );
   listViewInstance.dataSource = filteredData;

In the below sample, we can filter fruit items with the help of search text box. This will filter fruit items based on your input. Here we used startswith of input text to filter data in DataManager.

<template>
    <div id="sample">
        <div class="headerContainer">
            <div class="e-input-group">
                <input id="search" ref='searchEle' class="e-input" type="text" placeholder="Search fruits" @keyup='onKeyUp'/>
                <span class="e-input-group-icon e-input-search"></span>
            </div>
            <ejs-button id="sort" class="e-control e-btn e-small e-round e-primary e-icon-btn" v-on:click='sortItems' title="Sort fruits" data-ripple="true">
                <span class="e-btn-icon e-icons e-sort-icon-ascending"></span>
            </ejs-button>
            <ejs-button id="add" class="e-control e-btn e-small e-round e-primary e-icon-btn" v-on:click='addItem' title="Add fruit" data-ripple="true">
                <span class="e-btn-icon e-icons e-add-icon"></span>
            </ejs-button>
            <ejs-dialog id="dialog" ref='dialogObj' width='300px' :content='content' :visible='visible' header='Add Fruit' showCloseIcon='true' :buttons='addButtons' ></ejs-dialog>
        </div>
            <ejs-listview id='element' ref='listViewInstance' :dataSource='fruitsdata' :template='listTemplate' sortOrder='Ascending' :actionComplete='wireEvents'>
            </ejs-listview>
    </div>
</template>
<style>
#listImage {
    width: 55px;
    height: 55px;
    margin-left: 25px;
}

#sample {
    max-width: 440px;
    margin: auto;
    box-shadow: 0 3px 6px lightgray;
}

.headerContainer {
    height: 48px;
    line-height: 48px;
    background: rgb(2, 120, 215);
    color: white;
    margin-bottom: 3px;
}

.headerContainer .e-input-group {
    margin-left: 20px;
    width: 200px;
    background: white;
    height: 31px;
}

.headerContainer #search {
    height: 21px;
    margin-left: 10px;
}

#listDialog .input_name {
    margin-bottom: 20px;
}

.headerContainer #add,
.headerContainer #sort {
    float: right;
    margin-right: 15px;
    margin-top: 7px;
    background: white;
    color: black
}

.headerContainer .e-input-search::before {
    font-family: 'e-icons';
    content: '\e961';
    margin-top: 3px;
}

.headerContainer .e-input-group .e-input-group-icon.e-input-search {
    padding: 0 10px 0 10px;
}

#element .e-list-item {
    height: 110px;
    width: 110px;
    float: left;
    padding: 0;
    position: relative;
    user-select: none;
}

#element .e-delete-btn {
    float: right;
    visibility: hidden;
    margin-top: -10px;
}

#element .e-delete-btn.e-btn.e-small.e-round {
    width: 2em;
    height: 2em;
}

#element .e-btn.e-small.e-round .e-btn-icon.delete-icon {
    font-size: 9px;
}

#element .e-list-item:hover .e-delete-btn {
    visibility: visible;
    background: red;
    border-radius: 50%;
}

#element .fruits {
    height: inherit;
    width: inherit;
    padding: 10px 0 10px 0;
}

#element .fruitName {
    text-align: center;
}

.headerContainer .e-add-icon::before {
    content: '\e823';
}

#element .delete-icon::before {
    content: '\e7fc';
    color: white;
}

.headerContainer .e-sort-icon-ascending::before {
    content: '\e840';
}

.headerContainer .e-sort-icon-descending::before {
    content: '\e83f';
}
.e-dialog.e-control.e-popup.e-popup-open {
  max-height:361px !important;
}
</style>
<script>
import Vue from "vue";
import { ListViewPlugin } from "@syncfusion/ej2-vue-lists";
import { DialogPlugin } from '@syncfusion/ej2-vue-popups';
import { closest, enableRipple } from '@syncfusion/ej2-base';
import { DataManager, Query } from "@syncfusion/ej2-data";
enableRipple(true);

Vue.use(ListViewPlugin);
Vue.use(DialogPlugin);

var listVue = Vue.component("demo", {
  template: `<div class="fruits"><div class="first"><img id="listImage" :src="data.imgUrl" alt="fruit" /><ejs-button class="delete e-control e-btn e-small e-round e-delete-btn e-primary e-icon-btn" data-ripple="true"><span class="e-btn-icon e-icons delete-icon"></span></ejs-button></div><div class="fruitName"></div></div>`,
  data() {
    return {
      data: {}
    };
  }
});

var dialogVue = Vue.component("demo", {
  template: `<div id="listDialog"><div class="input_name"><label for="name">Fruit Name: </label><input id="name" class="e-input" type="text" placeholder="Enter fruit name"/></div><div><label for="imgurl">Fruit Image: </label><input id="imgurl" class="e-input" type="text" placeholder="Enter image url"/></div></div>`,
  data() {
    return {
      data: {}
    };
  }
});

export default {
  data: function() {
        return {
    fruitsdata: [
    { text: "Date", id: "1", imgUrl: "https://ej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/dates.jpg" },
    { text: "Fig", id: "2", imgUrl: "https://ej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/fig.jpg" },
    { text: "Apple", id: "3", imgUrl: "https://ej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/apple.png" },
    { text: "Apricot", id: "4", imgUrl: "https://ej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/apricot.jpg" },
    { text: "Grape", id: "5", imgUrl: "https://ej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/grape.jpg" },
    { text: "Strawberry", id: "6", imgUrl: "https://ej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/strawberry.jpg" },
    { text: "Pineapple", id: "7", imgUrl: "https://ej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/pineapple.jpg" },
    { text: "Melon", id: "8", imgUrl: "https://ej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/melon.jpg" },
    { text: "Lemon", id: "9", imgUrl: "https://ej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/lemon.jpg" },
    { text: "Cherry", id: "10", imgUrl: "https://ej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/cherry.jpg" }
],
    listTemplate: function () {
      return { template : listVue};
    },
    visible: false,
     content: function () {
      return { template : dialogVue};
    },
    addButtons: [{
        click: this.dlgButtonClick, buttonModel: { content: 'Add', isPrimary: true }
    }]
  };
},
methods: {
  wireEvents: function() {
    Array.prototype.forEach.call(document.getElementsByClassName('e-delete-btn'), (ele) => {
        ele.addEventListener('click', this.onDeleteBtnClick);
    });
    },
addItem: function() {
    (document.getElementById("name")).value = "";
    (document.getElementById("imgurl")).value = "";
    this.$refs.dialogObj.show();
},
sortItems: function() {
    let ele = document.getElementById("sort").firstElementChild;
    let des = ele.classList.contains('e-sort-icon-descending') ? true : false;
    if (des) {
        ele.classList.remove('e-sort-icon-descending');
        ele.classList.add('e-sort-icon-ascending');
        this.$refs.listViewInstance.sortOrder = 'Ascending';
    } else {
        ele.classList.remove('e-sort-icon-ascending');
        ele.classList.add('e-sort-icon-descending');
        this.$refs.listViewInstance.sortOrder = 'Descending'
    }
    this.$refs.listViewInstance.dataBind();
    this.wireEvents();
},
onKeyUp: function(e) {
    let value = this.$refs.searchEle.value;
    let data = new DataManager(this.fruitsdata).executeLocal(
        new Query().where("text", "startswith", value, true)
    );
    if (!value) {
        this.$refs.listViewInstance.dataSource = this.fruitsdata.slice();
    } else {
        this.$refs.listViewInstance.dataSource = data;
        this.$refs.listViewInstance.dataBind();
    }
},
onDeleteBtnClick: function(e) {
    e.stopPropagation();
    let li = closest(e.currentTarget, '.e-list-item');
    let data = this.$refs.listViewInstance.findItem(li);
    this.$refs.listViewInstance.removeItem(data);
    new DataManager(this.fruitsdata).remove('id', { id: data.id });
},
 dlgButtonClick: function() {
    let name = (document.getElementById("name")).value;
    let url = (document.getElementById("imgurl")).value;
    let id = Math.random() * 10000;
    this.$refs.listViewInstance.addItem([{ text: name, id: id, imgUrl: url }]);
    this.fruitsdata.push({ text: name, id: id, imgUrl: url });
    this.$refs.listViewInstance.$el.ej2_instances[0].element.querySelector('[data-uid="'+ id + '"]').getElementsByClassName('e-delete-btn')[0].addEventListener('click', this.onDeleteBtnClick);
    this.$refs.dialogObj.hide();
}
}
}
</script>

Manipulate listview as grid layout in React Listview component

30 Jan 202324 minutes to read

In Listview, list items can be rendered in grid layout with following data manipulations.

  • Add Item

  • Remove Item

  • Sort Items

  • Filter Items

Grid Layout

In this section, we will discuss about rendering of list items in grid layout.

  • Initialize and render ListView with dataSource which will render list items in list layout.

  • Now, add the below CSS to list item. This will make list items to render in grid layout

#default-list .e-list-item {
        height: 100px;
        width: 100px;
        float: left;
}

In the below sample, we have rendered List items in grid layout.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
function App() {
    //Define an array of number
    let data = [1, 2, 3, 4, 5, 6, 7, 8, 9];
    function listtemplate(data) {
        return (<img id="listImage" src="https://helpej2.syncfusion.com/documentation/code-snippet/listview/grid-layout-cs1/apple.png" alt="apple"/>);
    }
    ;
    return (<ListViewComponent id='list' dataSource={data} template={listtemplate}>
            </ListViewComponent>);
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { ListViewComponent } from '@syncfusion/ej2-react-lists';

function App() {

  //Define an array of number
  let data: number[] = [1, 2, 3, 4, 5, 6, 7, 8, 9];

  function listtemplate(data: any): JSX.Element {
    return (
        <img id="listImage" src="https://helpej2.syncfusion.com/documentation/code-snippet/listview/grid-layout-cs1/apple.png" alt="apple" />
    )};

  return (
    <ListViewComponent id='list'
            dataSource={data}
            template= {listtemplate as any} >
            </ListViewComponent>
    )
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));

Data manipulation

In this section, we will discuss about ListView data manipulations.

Add Item

We can add list item using addItem API. This will accept array of data as argument.

 listViewInstance.addItem([{text: 'Apricot', id: '32'}]);

In the below sample, you can add new fruit item by clicking add button which will open dialog box with fruit name and image URL text box. After entering the item details, click the add button. This will add your new fruit item.

Remove item

We can remove list item using removeItem API. This will accept fields with id or list item element as argument.

 listViewInstance.removeItem({id: '32'});

In the below sample, you can remove fruit by hovering the fruit item which will show delete button and click that delete button to delete that fruit from your list.

Sort Items

Listview can be sorted either in Ascending or Descending order. To enable sorting in your ListView, set sortOrder as Ascending or Descending.

<ListViewComponent id='list' sortOrder= 'Ascending'></ListViewComponent>

We can also set sorting after component initialization.

listViewInstance.sortOrder = 'Ascending'

In the below sample, we have sorted fruits in Ascending order. To sort it in descending, click on sort order icon and vice versa.

Filter Items

Listview data can be filtered with the help of dataManager. After filtering the data, update ListView dataSource with filtered data.

let value = filterInput.value;  //input text box value
let filteredData = new DataManager(listdata).executeLocal(
        new Query().where("text", "startswith", value, true)
);

listViewInstance.dataSource = filteredData;

In the below sample, we can filter fruit items with the help of search text box. This will filter fruit items based on your input. Here we used startswith of input text to filter data in DataManager.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
import { closest } from '@syncfusion/ej2-base';
import { DataManager, Query } from "@syncfusion/ej2-data";
import { DialogComponent } from '@syncfusion/ej2-react-popups';
function App() {
    let ascClass = "e-sort-icon-ascending";
    let desClass = "e-sort-icon-descending";
    //Define an array of JSON data
    let fruitsdata = [
        { text: "Date", id: "1", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/dates.jpg" },
        { text: "Fig", id: "2", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/fig.jpg" },
        { text: "Apple", id: "3", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/apple.png" },
        { text: "Apricot", id: "4", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/apricot.jpg" },
        { text: "Grape", id: "5", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/grape.jpg" },
        { text: "Strawberry", id: "6", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/strawberry.jpg" },
        { text: "Pineapple", id: "7", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/pineapple.jpg" },
        { text: "Melon", id: "8", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/melon.jpg" },
        { text: "Lemon", id: "9", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/lemon.jpg" },
        { text: "Cherry", id: "10", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/cherry.jpg" }
    ];
    let add = null;
    let search = null;
    let sort = null;
    let imgURL = null;
    let name = null;
    let dialogInstance = null;
    let listviewInstance = null;
    let buttonObj = [
        {
            click: dlgButtonClick.bind(this),
            buttonModel: { content: "Add", isPrimary: true }
        }
    ];
    function addItem() {
        if (name)
            name.value = "";
        if (imgURL)
            imgURL.value = "";
        if (dialogInstance)
            dialogInstance.show();
    }
    //Here we are removing list item
    function onDeleteBtnClick(e) {
        e.stopPropagation();
        let li = closest(e.currentTarget, ".e-list-item");
        let data = listviewInstance.findItem(li);
        listviewInstance.removeItem(data);
        new DataManager(fruitsdata).remove("id", { id: data["id"] });
    }
    //Here we are adding list item
    function dlgButtonClick() {
        if (listviewInstance && dialogInstance) {
            let name = name.value;
            let url = imgURL.value;
            let id = Math.random() * 10000;
            listviewInstance.addItem([{ text: name, id: id, imgUrl: url }]);
            fruitsdata.push({ text: name, id: id, imgUrl: url });
            dialogInstance.hide();
        }
    }
    //Here we are sorting list item
    function sortItems() {
        if (listviewInstance && sort) {
            let ele = sort.firstElementChild;
            let des = ele.classList.contains(desClass) ? true : false;
            if (des) {
                ele.classList.remove(desClass);
                ele.classList.add(ascClass);
                listviewInstance.sortOrder = "Ascending";
            }
            else {
                ele.classList.remove(ascClass);
                ele.classList.add(desClass);
                listviewInstance.sortOrder = "Descending";
            }
            listviewInstance.dataBind();
        }
    }
    //Here, the list items are filtered using the DataManager instance.
    function onKeyUp() {
        if (listviewInstance) {
            let value = search.value;
            let data = new DataManager(fruitsdata).executeLocal(new Query().where("text", "startswith", value, true));
            if (!value) {
                listviewInstance.dataSource = fruitsdata.slice();
            }
            else {
                listviewInstance.dataSource = data;
                listviewInstance.dataBind();
            }
        }
    }
    function content(data) {
        return (<div id="listDialog">
        <div className="input_name">
          <label htmlFor="name">Fruit Name: </label>
          <input id="name" ref={scope => {
                name = scope;
            }} className="e-input" type="text" placeholder="Enter fruit name"/>
        </div>
        <div>
          <label htmlFor="imgurl">Fruit Image: </label>
          <input id="imgurl" ref={scope => {
                imgURL = scope;
            }} className="e-input" type="text" placeholder="Enter image url"/>
        </div>
      </div>);
    }
    function listtemplate(data) {
        return (<div className="fruits">
        <div className="first">
          <img id="listImage" src={data.imgUrl} alt="fruit"/>
          <button className="delete e-control e-btn e-small e-round e-delete-btn e-primary e-icon-btn" data-ripple="true">
            <span className="e-btn-icon e-icons delete-icon" onClick={onDeleteBtnClick.bind(this)}/>
          </button>
        </div>
        <div className="fruitName">{data.text}</div>
      </div>);
    }
    return (<div id="container">
      <div className="headerContainer">
        <div className="e-input-group">
          <input id="search" ref={scope => {
            search = scope;
        }} className="e-input" type="text" onKeyUp={onKeyUp.bind(this)} placeholder="Search fruits"/>
          <span className="e-input-group-icon e-input-search"/>
        </div>

        <button id="sort" className="e-control e-btn e-small e-round e-primary e-icon-btn" ref={scope => {
            sort = scope;
        }} title="Sort fruits" onClick={sortItems.bind(this)} data-ripple="true">
          <span className="e-btn-icon e-icons e-sort-icon-ascending"/>
        </button>

        <button id="add" className="e-control e-btn e-small e-round e-primary e-icon-btn" ref={scope => {
            add = scope;
        }} onClick={addItem.bind(this)} title="Add fruit" data-ripple="true">
          <span className="e-btn-icon e-icons e-add-icon"/>
        </button>
      </div>

      <ListViewComponent id="list" dataSource={fruitsdata.slice()} template={listtemplate.bind(this)} sortOrder="Ascending" ref={scope => {
            listviewInstance = scope;
        }}/>

      <DialogComponent id="dialog" header="Add fruit" content={content.bind(this)} visible={false} buttons={buttonObj} ref={dialog => (dialogInstance = dialog)} width={"300px"} showCloseIcon={true}/>
    </div>);
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
import { closest, enableRipple, MouseEventArgs } from '@syncfusion/ej2-base';
import { DataManager, Query } from "@syncfusion/ej2-data";
import { DialogComponent } from '@syncfusion/ej2-react-popups';

function App() {
  let ascClass: string = "e-sort-icon-ascending";
  let desClass: string = "e-sort-icon-descending";
  //Define an array of JSON data
  let fruitsdata: { [key: string]: Object }[] = [
    { text: "Date", id: "1", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/dates.jpg" },
    { text: "Fig", id: "2", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/fig.jpg" },
    { text: "Apple", id: "3", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/apple.png" },
    { text: "Apricot", id: "4", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/apricot.jpg" },
    { text: "Grape", id: "5", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/grape.jpg" },
    { text: "Strawberry", id: "6", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/strawberry.jpg" },
    { text: "Pineapple", id: "7", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/pineapple.jpg" },
    { text: "Melon", id: "8", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/melon.jpg" },
    { text: "Lemon", id: "9", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/lemon.jpg" },
    { text: "Cherry", id: "10", imgUrl: "https://helpej2.syncfusion.com/documentation/code-snippet/listview/manipulation-cs1/cherry.jpg" }
  ];

  let add: HTMLElement | null = null;
  let search: HTMLInputElement | null = null;
  let sort: HTMLElement | null = null;
  let imgURL: HTMLInputElement | null = null;
  let name: HTMLInputElement | null = null;
  let dialogInstance: DialogComponent | null = null;
  let listviewInstance: ListViewComponent | null = null;
  let buttonObj = [
    {
      click: dlgButtonClick.bind(this),
      buttonModel: { content: "Add", isPrimary: true }
    }
  ];

  function addItem() {
    if (name) name.value = "";
    if (imgURL) imgURL.value = "";
    if (dialogInstance) dialogInstance.show();
  }

  //Here we are removing list item
  function onDeleteBtnClick(e: any) {
    e.stopPropagation();
    let li: Element = closest(e.currentTarget, ".e-list-item");
    let data = (listviewInstance as any).findItem(li);
    (listviewInstance as any).removeItem(data);
    new DataManager(fruitsdata).remove("id", { id: data["id"] });
  }

  //Here we are adding list item
  function dlgButtonClick() {
    if (listviewInstance && dialogInstance) {
      let name: string = (name as any).value;
      let url: string = (imgURL as any).value;
      let id: number = Math.random() * 10000;
      listviewInstance.addItem([{ text: name, id: id, imgUrl: url }]);
      fruitsdata.push({ text: name, id: id, imgUrl: url });
      dialogInstance.hide();
    }
  }

  //Here we are sorting list item
  function sortItems() {
    if (listviewInstance && sort) {
      let ele = sort.firstElementChild as HTMLElement;
      let des = ele.classList.contains(desClass) ? true : false;
      if (des) {
        ele.classList.remove(desClass);
        ele.classList.add(ascClass);
        listviewInstance.sortOrder = "Ascending";
      } else {
        ele.classList.remove(ascClass);
        ele.classList.add(desClass);
        listviewInstance.sortOrder = "Descending";
      }
      listviewInstance.dataBind();
    }
  }

  //Here, the list items are filtered using the DataManager instance.
  function onKeyUp() {
    if (listviewInstance) {
      let value: string = (search as any).value;
      let data: Object[] = new DataManager(fruitsdata).executeLocal(
        new Query().where("text", "startswith", value, true)
      );
      if (!value) {
        listviewInstance.dataSource = fruitsdata.slice();
      } else {
        listviewInstance.dataSource = data as { [key: string]: Object }[];
        listviewInstance.dataBind();
      }
    }
  }

  function content(data: any): JSX.Element {
    return (
      <div id="listDialog">
        <div className="input_name">
          <label htmlFor="name">Fruit Name: </label>
          <input
            id="name"
            ref={scope => {
              name = scope;
            }}
            className="e-input"
            type="text"
            placeholder="Enter fruit name"
          />
        </div>
        <div>
          <label htmlFor="imgurl">Fruit Image: </label>
          <input
            id="imgurl"
            ref={scope => {
              imgURL = scope;
            }}
            className="e-input"
            type="text"
            placeholder="Enter image url"
          />
        </div>
      </div>
    );
  }

  function listtemplate(data: any): JSX.Element {
    return (
      <div className="fruits">
        <div className="first">
          <img id="listImage" src={data.imgUrl} alt="fruit" />
          <button
            className="delete e-control e-btn e-small e-round e-delete-btn e-primary e-icon-btn"
            data-ripple="true"
          >
            <span
              className="e-btn-icon e-icons delete-icon"
              onClick={onDeleteBtnClick.bind(this)}
            />
          </button>
        </div>
        <div className="fruitName">{data.text}</div>
      </div>
    );
  }
  return (
    <div id="container">
      <div className="headerContainer">
        <div className="e-input-group">
          <input
            id="search"
            ref={scope => {
              search = scope;
            }}
            className="e-input"
            type="text"
            onKeyUp={onKeyUp.bind(this)}
            placeholder="Search fruits"
          />
          <span className="e-input-group-icon e-input-search" />
        </div>

        <button
          id="sort"
          className="e-control e-btn e-small e-round e-primary e-icon-btn"
          ref={scope => {
            sort = scope;
          }}
          title="Sort fruits"
          onClick={sortItems.bind(this)}
          data-ripple="true"
        >
          <span className="e-btn-icon e-icons e-sort-icon-ascending" />
        </button>

        <button
          id="add"
          className="e-control e-btn e-small e-round e-primary e-icon-btn"
          ref={scope => {
            add = scope;
          }}
          onClick={addItem.bind(this)}
          title="Add fruit"
          data-ripple="true"
        >
          <span className="e-btn-icon e-icons e-add-icon" />
        </button>
      </div>

      <ListViewComponent
        id="list"
        dataSource={fruitsdata.slice()}
        template={listtemplate.bind(this) as any}
        sortOrder="Ascending"
        ref={scope => {
          listviewInstance = scope;
        }}
      />

      <DialogComponent
        id="dialog"
        header="Add fruit"
        content={content.bind(this) as any}
        visible={false}
        buttons={buttonObj}
        ref={dialog => (dialogInstance = dialog)}
        width={"300px"}
        showCloseIcon={true}
      />
    </div>
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));

Manipulate listview as grid layout in Angular Listview component

27 Sep 202314 minutes to read

In Listview, list items can be rendered in grid layout with following data manipulations.

  • Add Item

  • Remove Item

  • Sort Items

  • Filter Items

Grid Layout

In this section, we will discuss about rendering of list items in grid layout.

  • Initialize and render ListView with dataSource which will render list items in list layout.

  • Now, add the below CSS to list item. This will make list items to render in grid layout

      ```css
    
      #element .e-list-item {
              height: 100px;
              width: 100px;
              float: left;
      }
    
      ```
    

In the below sample, we have rendered List items in grid layout.

import { Component, ViewChild } from '@angular/core';

@Component({
    selector: 'my-app',
    template: `
          <ejs-listview id='element' [dataSource]='data'>
          <ng-template #template let-data="">
          <img id="listImage" src="./apple.png" alt="apple" />
          </ng-template>
          </ejs-listview>
        `,
  })

export class AppComponent {
  public data = [1, 2, 3, 4, 5, 6, 7, 8, 9];
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { ListViewModule } from '@syncfusion/ej2-angular-lists';
/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        ListViewModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

import 'zone.js';
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Data manipulation

In this section, we will discuss about ListView data manipulations.

Add Item

We can add list item using addItem API. This will accept array of data as argument.

 this.$refs.listViewInstance.addItem([{text: 'Apricot', id: '32'}]);

In the below sample, you can add new fruit item by clicking add button which will open dialog box with fruit name and image URL text box. After entering the item details, click the add button. This will add your new fruit item.

Remove item

We can remove list item using removeItem API. This will accept fields with id or list item element as argument.

 this.$refs.listViewInstance.removeItem({id: '32'});

In the below sample, you can remove fruit by hovering the fruit item which will show delete button and click that delete button to delete that fruit from your list.

Sort Items

Listview can be sorted either in Ascending or Descending order. To enable sorting in your ListView, set sortOrder as Ascending or Descending.

<ejs-listview sortOrder='Ascending'></ejs-listview>

We can also set sorting after component initialization.

this.listViewInstance.sortOrder = 'Ascending'

In the below sample, we have sorted fruits in Ascending order. To sort it in descending, click on sort order icon and vice versa.

Filter Items

Listview data can be filtered with the help of dataManager. After filtering the data, update ListView dataSource with filtered data.

let value = this.textboxEle.nativeElement.value;  //input text box value
let filteredData = new DataManager(this.listdata).executeLocal(
        new Query().where("text", "startswith", value, true)
);

listViewInstance.dataSource = filteredData;

In the below sample, we can filter fruit items with the help of search text box. This will filter fruit items based on your input. Here we used startswith of input text to filter data in DataManager.

import { Component, ViewChild, ElementRef } from '@angular/core';
import { closest, enableRipple } from '@syncfusion/ej2-base';
import { DataManager, Query } from "@syncfusion/ej2-data";
enableRipple(true);

@Component({
    selector: 'my-app',
    template: `
          <div id="sample">
        <div class="headerContainer">
            <div class="e-input-group">
                <input id="search" #searchEle class="e-input" type="text" placeholder="Search fruits" (keyup)='onKeyUp($event)'/>
                <span class="e-input-group-icon e-input-search"></span>
            </div>
            <button ejs-button id="sort" class="e-control e-btn e-small e-round e-primary e-icon-btn" (click)='sortItems($event)' title="Sort fruits" data-ripple="true">
                <span class="e-btn-icon e-icons e-sort-icon-ascending"></span>
            </button>
            <button ejs-button id="add" class="e-control e-btn e-small e-round e-primary e-icon-btn" (click)='addItem($event)' title="Add fruit" data-ripple="true">
                <span class="e-btn-icon e-icons e-add-icon"></span>
            </button>
            <ejs-dialog id="dialog" #dialogObj width='300px' [visible]='false' header='Add Fruit' showCloseIcon='true' [buttons]='addButtons'>
            <ng-template #content let-data="">
            <div id="listDialog"><div class="input_name"><label for="name">Fruit Name: </label><input id="name" class="e-input" type="text" placeholder="Enter fruit name"/></div><div><label for="imgurl">Fruit Image: </label><input id="imgurl" class="e-input" type="text" placeholder="Enter image url"/></div></div>
            </ng-template>
            </ejs-dialog>
        </div>
            <ejs-listview id='element' #listview [dataSource]='fruitsdata' sortOrder='Ascending' (actionComplete)='wireEvents()'>
            <ng-template #template let-data="">
            <div class="fruits"><div class="first"><img id="listImage" src= alt="fruit" /><button ejs-button class="delete e-control e-btn e-small e-round e-delete-btn e-primary e-icon-btn" data-ripple="true"><span class="e-btn-icon e-icons delete-icon"></span></button></div><div class="fruitName"></div></div>
            </ng-template>
            </ejs-listview>
    </div>
        `,
  })

export class AppComponent {
  @ViewChild('listview') listViewInstance: any;
  @ViewChild('dialogObj')dialogObj: any;
  @ViewChild('searchEle')searchEle: any;
  public  fruitsdata = [
    { text: 'Date', id: '1', imgUrl: './dates.jpg' },
    { text: 'Fig', id: '2', imgUrl: './fig.jpg' },
    { text: 'Apple', id: '3', imgUrl: './apple.png' },
    { text: 'Apricot', id: '4', imgUrl: './apricot.jpg' },
    { text: 'Grape', id: '5', imgUrl: './grape.jpg' },
    { text: 'Strawberry', id: '6', imgUrl: './strawberry.jpg' },
    { text: 'Pineapple', id: '7', imgUrl: './pineapple.jpg' },
    { text: 'Melon', id: '8', imgUrl: './melon.jpg' },
    { text: 'Lemon', id: '9', imgUrl: './lemon.jpg' },
    { text: 'Cherry', id: '10', imgUrl: './cherry.jpg' },
];
public addButtons= [{
        click: this.dlgButtonClick.bind(this), buttonModel: { content: 'Add', isPrimary: true }
    }];
 wireEvents() {
    Array.prototype.forEach.call(document.getElementsByClassName('e-delete-btn'), (ele) => {
        ele.addEventListener('click', this.onDeleteBtnClick.bind(this));
    });
}
addItem(args: any) {
    (document.getElementById("name") as HTMLElement | any).value = "";
    (document.getElementById("imgurl") as HTMLElement | any).value = "";
    this.dialogObj.show();
}
sortItems(args: any) {
    let ele = (document.getElementById("sort") as HTMLElement).firstElementChild;
    let des = (ele as Element).classList.contains('e-sort-icon-descending') ? true : false;
    if (des) {
        (ele as Element).classList.remove('e-sort-icon-descending');
        (ele as Element).classList.add('e-sort-icon-ascending');
        this.listViewInstance.sortOrder = 'Ascending';
    } else {
        (ele as Element).classList.remove('e-sort-icon-ascending');
        (ele as Element).classList.add('e-sort-icon-descending');
        this.listViewInstance.sortOrder = 'Descending'
    }
    this.listViewInstance?.dataBind();
    this.wireEvents();
}
onKeyUp(e: any) {
    let value = this.searchEle.nativeElement.value;
    let data = new DataManager(this.fruitsdata).executeLocal(
        new Query().where("text", "startswith", value, true)
    );
    if (!value) {
        this.listViewInstance.dataSource = this.fruitsdata.slice();
    } else {
        this.listViewInstance.dataSource = data;
        this.listViewInstance?.dataBind();
    }
}
onDeleteBtnClick(e: any) {
    e.stopPropagation();
    let li = closest(e.currentTarget, '.e-list-item');
    let data = this.listViewInstance?.findItem(li);
    this.listViewInstance?.removeItem(data);
    new DataManager(this.fruitsdata).remove('id', { id: data.id });
}
 dlgButtonClick() {
    let name = (document.getElementById("name") as HTMLElement | any).value;
    let url = (document.getElementById("imgurl") as HTMLElement | any).value;
    let id = Math.random() * 10000;
    this.listViewInstance?.addItem([{ text: name, id: id, imgUrl: url }]);
    this.fruitsdata.push({ text: name, id: 'id', imgUrl: url });
    this.listViewInstance?.element.querySelector('[data-uid="'+ id + '"]').getElementsByClassName('e-delete-btn')[0].addEventListener('click', this.onDeleteBtnClick.bind(this));
    this.dialogObj.hide();
}
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { ListViewModule } from '@syncfusion/ej2-angular-lists';
import { DialogComponent, DialogModule } from '@syncfusion/ej2-angular-popups';
/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        ListViewModule,
        DialogModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

import 'zone.js';
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);